package cn.ezhizao.project.system.service.impl;

import cn.ezhizao.common.constant.Constants;
import cn.ezhizao.common.constant.UserConstants;
import cn.ezhizao.common.utils.SecurityUtils;
import cn.ezhizao.common.utils.StringUtils;
import cn.ezhizao.framework.web.domain.TreeSelect;
import cn.ezhizao.framework.web.domain.server.Sys;
import cn.ezhizao.project.system.domain.*;
import cn.ezhizao.project.system.domain.vo.MetaVo;
import cn.ezhizao.project.system.domain.vo.RouterVo;
import cn.ezhizao.project.system.mapper.SysMenuMapper;
import cn.ezhizao.project.system.mapper.SysRoleInItMapper;
import cn.ezhizao.project.system.mapper.SysRoleMapper;
import cn.ezhizao.project.system.mapper.SysRoleMenuMapper;
import cn.ezhizao.project.system.service.*;
import cn.ezhizao.project.tenant.domain.BizUserTenant;
import cn.ezhizao.project.tenant.domain.Tenant;
import cn.ezhizao.project.tenant.mapper.BizUserTenantMapper;
import cn.ezhizao.project.tenant.mapper.TenantMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.*;
import java.util.stream.Collectors;

/**
 * 菜单 业务层处理
 *
 * @author ruoyi
 */
@Service
public class SysMenuServiceImpl implements ISysMenuService
{
    public static final String PREMISSION_STRING = "perms[\"{0}\"]";

    @Resource
    private SysMenuMapper menuMapper;

    @Resource
    private SysRoleMapper roleMapper;

    @Resource
    private SysRoleMenuMapper roleMenuMapper;

    @Resource
    private BizUserTenantMapper userTenantMapper;

    @Resource
    private TenantMapper tenantMapper;
    @Resource
    private ISysVersionService versionService;
    @Resource
    private ISysVersionMenuService versionMenuService;
    @Resource
    private ISysModuleDetailService moduleDetailService;
    @Resource
    private ISysModuleService moduleService;
    @Resource
    private SysRoleInItMapper roleInItMapper;

    @Resource
    private HttpServletRequest request;

    /**
     * 根据用户查询系统菜单列表
     *
     * @param userId 用户ID
     * @return 菜单列表
     */
    @Override
    public List<SysMenu> selectMenuList(Long userId)
    {
        return selectMenuList(new SysMenu(), userId);
    }

    /**
     * 查询系统菜单列表
     *
     * @param menu 菜单信息
     * @return 菜单列表
     */
    @Override
    public List<SysMenu> selectMenuList(SysMenu menu, Long userId)
    {
        String appKey = request.getHeader("appKey");
        if(!"ezhizao-identity".equals(appKey)){
            menu.setAppKey(appKey);
        }
        List<SysMenu> menuList = null;
        // 管理员显示所有菜单信息
        if (SysUser.isAdmin(userId))
        {
            menuList = menuMapper.selectMenuList(menu);
        }
        else
        {
//            menu.getParams().put("userId", userId);
            Long tenantId = SecurityUtils.getTenantId();
            Tenant tenant = tenantMapper.selectById(tenantId);
//            menuList = menuMapper.selectMenuTreeByVersionId(tenant.getVersionId(), appKey);
            menu.setVersionId(tenant.getVersionId());
            menuList = menuMapper.selectMenuList(menu);
        }
        return menuList;
    }

    /**
     * 根据用户ID查询权限
     *
     * @param userId 用户ID
     * @return 权限列表
     */
    @Override
    public Set<String> selectMenuPermsByUserId(Long userId)
    {
        List<String> perms = menuMapper.selectMenuPermsByUserId(userId);
        Set<String> permsSet = new HashSet<>();
        for (String perm : perms)
        {
            if (StringUtils.isNotEmpty(perm))
            {
                permsSet.addAll(Arrays.asList(perm.trim().split(",")));
            }
        }
        return permsSet;
    }

    /**
     * 根据角色ID查询权限
     *
     * @param roleId 角色ID
     * @return 权限列表
     */
    @Override
    public Set<String> selectMenuPermsByRoleId(Long roleId)
    {
        List<String> perms = menuMapper.selectMenuPermsByRoleId(roleId);
        Set<String> permsSet = new HashSet<>();
        for (String perm : perms)
        {
            if (StringUtils.isNotEmpty(perm))
            {
                permsSet.addAll(Arrays.asList(perm.trim().split(",")));
            }
        }
        return permsSet;
    }

    /**
     * 根据用户ID查询菜单
     *
     * @param userId 用户名称
     * @return 菜单列表
     */
    @Override
    public List<SysMenu> selectMenuTreeByUserId(Long userId)

    {
        String appKey = request.getHeader("appKey");
        SysMenu menu = new SysMenu();
        menu.setAppKey(appKey);
        List<SysMenu> menus = null;
        String tenantId = request.getHeader("tenantId");
        // 判断假设是 管理员
        // 假设有tenantId != 0 则获取 tenantId 对应的版本的所有menu
        // 假设tenantId = 0 则获取管理版本的所有menu
        // 假设不是管理员则获取 对应版本的所有menu
        if (SecurityUtils.isAdmin(userId))
        {
            menus = menuMapper.selectMenuTreeAll(menu);
            // 根据选择的 tenantId 来刷取目录
            List<SysVersionMenu> modules = versionMenuService.query().eq("version_id", 0).list();
            // 假设前台获取的tenantId 不是0L 则获取 0 和当前 tenantId 的目录
            if ("0".equals(tenantId)) {
                List<SysModuleDetail> details = moduleDetailService.query().in("module_id", modules.stream().map(SysVersionMenu::getModuleId).collect(Collectors.toList())).list();
                menus = menus.stream().filter(v -> details.stream().anyMatch(l -> l.getMenuId().equals(v.getMenuId()))).collect(Collectors.toList());
            } else {

                Tenant tenant = tenantMapper.selectById(tenantId);
                modules.addAll(versionMenuService.query().eq("version_id", tenant.getVersionId()).list());
                List<SysModuleDetail> details = moduleDetailService.query().in("module_id", modules.stream().map(SysVersionMenu::getModuleId).collect(Collectors.toList())).list();
                menus = menus.stream().filter(v -> details.stream().anyMatch(l -> l.getMenuId().equals(v.getMenuId()))).collect(Collectors.toList());
            }
        }
        else
        {
            menu.setUserId(userId);
            menus = menuMapper.selectMenuTreeByUserId(menu);
            Tenant tenant = tenantMapper.selectById(tenantId);
            List<SysVersionMenu> modules = new ArrayList<>(versionMenuService.query().eq("version_id", tenant.getVersionId()).list());
            List<SysModuleDetail> details = moduleDetailService.query().in("module_id", modules.stream().map(SysVersionMenu::getModuleId).collect(Collectors.toList())).list();
            menus = menus.stream().filter(v -> details.stream().anyMatch(l -> l.getMenuId().equals(v.getMenuId()))).collect(Collectors.toList());
        }
        return getChildPerms(menus, 0);
    }
    @Override
    public List<SysModule> selectModuleByUserId(Long userId)
    {
        String appKey = request.getHeader("appKey");
        SysMenu menu = new SysMenu();
        menu.setAppKey(appKey);
        List<SysMenu> menus = null;
        List<SysModule> resModules = null;
        String tenantId = request.getHeader("tenantId");
        // 判断假设是 管理员
        // 假设有tenantId != 0 则获取 tenantId 对应的版本的所有menu
        // 假设tenantId = 0 则获取管理版本的所有menu
        // 假设不是管理员则获取 对应版本的所有menu
        if (SecurityUtils.isAdmin(userId))
        {
            menus = menuMapper.selectMenuTreeAll(menu);
            // 根据选择的 tenantId 来刷取目录
            List<SysVersionMenu> modules = versionMenuService.query().eq("version_id", 0).list();
            // 假设前台获取的tenantId 不是0L 则获取 0 和当前 tenantId 的目录
            if ("0".equals(tenantId)) {
                resModules = moduleService.query().in("id", modules.stream().map(SysVersionMenu::getModuleId).collect(Collectors.toList())).list();
                List<SysModuleDetail> details = moduleDetailService.query().in("module_id", modules.stream().map(SysVersionMenu::getModuleId).collect(Collectors.toList())).list();
                List<SysMenu> finalMenus = menus;
                resModules.forEach(t -> {
                    t.setMenus(getChildPerms(finalMenus.stream().filter(v -> details.stream().filter(l -> l.getModuleId().equals(t.getId())).anyMatch(l -> l.getMenuId().equals(v.getMenuId()))).collect(Collectors.toList()), 0));
                    SysVersionMenu itemVersionMenu = modules.stream().filter(v -> v.getModuleId().equals(t.getId())).findFirst().orElse(null);
                    t.setSort(itemVersionMenu == null ? 0 : itemVersionMenu.getSerialNumber());
                });
            } else {
                Tenant tenant = tenantMapper.selectById(tenantId);
                modules.addAll(versionMenuService.query().eq("version_id", tenant.getVersionId()).list());
                resModules = moduleService.query().in("id", modules.stream().map(SysVersionMenu::getModuleId).collect(Collectors.toList())).list();
                List<SysModuleDetail> details = moduleDetailService.query().in("module_id", modules.stream().map(SysVersionMenu::getModuleId).collect(Collectors.toList())).list();
                List<SysMenu> finalMenus = menus;
                resModules.forEach(t -> {
                    t.setMenus(getChildPerms(finalMenus.stream().filter(v -> details.stream().filter(l -> l.getModuleId().equals(t.getId())).anyMatch(l -> l.getMenuId().equals(v.getMenuId()))).collect(Collectors.toList()), 0));
                    SysVersionMenu itemVersionMenu = modules.stream().filter(v -> v.getModuleId().equals(t.getId())).findFirst().orElse(null);
                    t.setSort(itemVersionMenu == null ? 0 : itemVersionMenu.getSerialNumber());
                });
            }
        }
        else
        {
            menu.setUserId(userId);
            menus = menuMapper.selectMenuTreeByUserId(menu);
            Tenant tenant = tenantMapper.selectById(tenantId);
            List<SysVersionMenu> modules = new ArrayList<>(versionMenuService.query().eq("version_id", tenant.getVersionId()).list());
            resModules = moduleService.query().in("id", modules.stream().map(SysVersionMenu::getModuleId).collect(Collectors.toList())).list();
            List<SysModuleDetail> details = moduleDetailService.query().in("module_id", modules.stream().map(SysVersionMenu::getModuleId).collect(Collectors.toList())).list();
            List<SysMenu> finalMenus = menus;
            resModules.forEach(t -> {
                t.setMenus(getChildPerms(finalMenus.stream().filter(v -> details.stream().filter(l -> l.getModuleId().equals(t.getId())).anyMatch(l -> l.getMenuId().equals(v.getMenuId()))).collect(Collectors.toList()), 0));
                SysVersionMenu itemVersionMenu = modules.stream().filter(v -> v.getModuleId().equals(t.getId())).findFirst().orElse(null);
                t.setSort(itemVersionMenu == null ? 0 : itemVersionMenu.getSerialNumber());
            });
        }
        resModules.sort(Comparator.comparingInt(SysModule::getSort));
        return resModules;
    }


    @Override
    public List<SysMenu> selectMenuTreeByTenantId(Long tenantId)
    {
        String appKey = request.getHeader("appKey");
        SysMenu menu = new SysMenu();
        menu.setAppKey(appKey);
        List<SysMenu> menus = null;
        // 判断假设是 管理员
        // 假设有tenantId != 0 则获取 tenantId 对应的版本的所有menu
        // 假设tenantId = 0 则获取管理版本的所有menu


//        if (SecurityUtils.isAdmin(userId))
//        {
//            menus = menuMapper.selectMenuTreeAll(menu);
//        }
//        else
//        {
//            menu.setUserId(userId);
//            menus = menuMapper.selectMenuTreeByUserId(menu);
//        }
        QueryWrapper<BizUserTenant> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("user_id", tenantId);
        BizUserTenant bizUserTenant = userTenantMapper.selectOne(queryWrapper);
        if (bizUserTenant != null) {
            if (SecurityUtils.isAdmin(tenantId)) {
                Tenant tenant = tenantMapper.selectById(bizUserTenant.getTenantId());
                menus = menuMapper.selectMenuTreeByVersionId(tenant.getVersionId(), appKey);
            } else {
                menu.setUserId(tenantId);
                menus = menuMapper.selectMenuTreeByUserId(menu);
            }
        }
        return getChildPerms(menus, 0);
    }

    /**
     * 根据角色ID查询菜单树信息
     *
     * @param roleId 角色ID
     * @return 选中菜单列表
     */
    @Override
    public List<Long> selectMenuInItListByRoleId(Long roleId) {
        SysRoleInIt role = roleInItMapper.getById(roleId);
        return menuMapper.selectMenuInItListByRoleId(roleId,role.isMenuCheckStrictly());
    }


    /**
     * 根据角色ID查询菜单树信息
     *
     * @param roleId 角色ID
     * @return 选中菜单列表
     */
    @Override
    public List<Long> selectMenuListByRoleId(Long roleId)
    {
        SysRole role = roleMapper.selectRoleById(roleId);
        return menuMapper.selectMenuListByRoleId(roleId, role.isMenuCheckStrictly());
    }

    /**
     * 构建前端路由所需要的菜单
     *
     * @param menus 菜单列表
     * @return 路由列表
     */
    @Override
    public List<RouterVo> buildMenus(List<SysMenu> menus)
    {
        List<RouterVo> routers = new LinkedList<RouterVo>();
        for (SysMenu menu : menus)
        {
            RouterVo router = new RouterVo();
            router.setHidden("1".equals(menu.getVisible()));
            router.setName(getRouteName(menu));
            router.setPath(getRouterPath(menu));
            router.setComponent(getComponent(menu));
            router.setQuery(menu.getQuery());
            router.setMeta(new MetaVo(menu.getMenuName(), menu.getIcon(), StringUtils.equals("1", menu.getIsCache()), menu.getPath()));
            List<SysMenu> cMenus = menu.getChildren();
            if (!cMenus.isEmpty() && cMenus.size() > 0 && UserConstants.TYPE_DIR.equals(menu.getMenuType()))
            {
                router.setAlwaysShow(true);
                router.setRedirect("noRedirect");
                router.setChildren(buildMenus(cMenus));
            }
            else if (isMenuFrame(menu))
            {
                router.setMeta(null);
                List<RouterVo> childrenList = new ArrayList<RouterVo>();
                RouterVo children = new RouterVo();
                children.setPath(menu.getPath());
                children.setComponent(menu.getComponent());
                children.setName(StringUtils.capitalize(menu.getPath()));
                children.setMeta(new MetaVo(menu.getMenuName(), menu.getIcon(), StringUtils.equals("1", menu.getIsCache()), menu.getPath()));
                children.setQuery(menu.getQuery());
                childrenList.add(children);
                router.setChildren(childrenList);
            }
            else if (menu.getParentId().intValue() == 0 && isInnerLink(menu))
            {
                router.setMeta(new MetaVo(menu.getMenuName(), menu.getIcon()));
                router.setPath("/");
                List<RouterVo> childrenList = new ArrayList<RouterVo>();
                RouterVo children = new RouterVo();
                String routerPath = innerLinkReplaceEach(menu.getPath());
                children.setPath(routerPath);
                children.setComponent(UserConstants.INNER_LINK);
                children.setName(StringUtils.capitalize(routerPath));
                children.setMeta(new MetaVo(menu.getMenuName(), menu.getIcon(), menu.getPath()));
                childrenList.add(children);
                router.setChildren(childrenList);
            }
            routers.add(router);
        }
        return routers;
    }

    /**
     * 构建前端所需要树结构
     *
     * @param menus 菜单列表
     * @return 树结构列表
     */
    @Override
    public List<SysMenu> buildMenuTree(List<SysMenu> menus)
    {
        List<SysMenu> returnList = new ArrayList<SysMenu>();
        List<Long> tempList = new ArrayList<Long>();
        for (SysMenu dept : menus)
        {
            tempList.add(dept.getMenuId());
        }
        for (Iterator<SysMenu> iterator = menus.iterator(); iterator.hasNext();)
        {
            SysMenu menu = (SysMenu) iterator.next();
            // 如果是顶级节点, 遍历该父节点的所有子节点
            if (!tempList.contains(menu.getParentId()))
            {
                recursionFn(menus, menu);
                returnList.add(menu);
            }
        }
        if (returnList.isEmpty())
        {
            returnList = menus;
        }
        return returnList;
    }

    /**
     * 构建前端所需要下拉树结构
     *
     * @param menus 菜单列表
     * @return 下拉树结构列表
     */
    @Override
    public List<TreeSelect> buildMenuTreeSelect(List<SysMenu> menus)
    {
        List<SysMenu> menuTrees = buildMenuTree(menus);
        return menuTrees.stream().map(TreeSelect::new).collect(Collectors.toList());
    }

    /**
     * 根据菜单ID查询信息
     *
     * @param menuId 菜单ID
     * @return 菜单信息
     */
    @Override
    public SysMenu selectMenuById(Long menuId)
    {
        return menuMapper.selectMenuById(menuId);
    }

    /**
     * 是否存在菜单子节点
     *
     * @param menuId 菜单ID
     * @return 结果
     */
    @Override
    public boolean hasChildByMenuId(Long menuId)
    {
        int result = menuMapper.hasChildByMenuId(menuId);
        return result > 0;
    }

    /**
     * 查询菜单使用数量
     *
     * @param menuId 菜单ID
     * @return 结果
     */
    @Override
    public boolean checkMenuExistRole(Long menuId)
    {
        int result = roleMenuMapper.checkMenuExistRole(menuId);
        return result > 0;
    }

    /**
     * 新增保存菜单信息
     *
     * @param menu 菜单信息
     * @return 结果
     */
    @Override
    public int insertMenu(SysMenu menu)
    {
        return menuMapper.insertMenu(menu);
    }

    /**
     * 修改保存菜单信息
     *
     * @param menu 菜单信息
     * @return 结果
     */
    @Override
    public int updateMenu(SysMenu menu)
    {
        return menuMapper.updateMenu(menu);
    }

    @Override
    public int updateChildMenuAppKey(SysMenu menu) {
        return menuMapper.updateChildMenuAppKey(menu);
    }

    /**
     * 删除菜单管理信息
     *
     * @param menuId 菜单ID
     * @return 结果
     */
    @Override
    public int deleteMenuById(Long menuId)
    {
        return menuMapper.deleteMenuById(menuId);
    }

    /**
     * 校验菜单名称是否唯一
     *
     * @param menu 菜单信息
     * @return 结果
     */
    @Override
    public String checkMenuNameUnique(SysMenu menu)
    {
        Long menuId = StringUtils.isNull(menu.getMenuId()) ? -1L : menu.getMenuId();
        SysMenu info = menuMapper.checkMenuNameUnique(menu.getMenuName(), menu.getParentId());
        if (StringUtils.isNotNull(info) && info.getMenuId().longValue() != menuId.longValue())
        {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    /**
     * 获取路由名称
     *
     * @param menu 菜单信息
     * @return 路由名称
     */
    public String getRouteName(SysMenu menu)
    {
        String routerName = StringUtils.capitalize(menu.getPath());
        // 非外链并且是一级目录（类型为目录）
        if (isMenuFrame(menu))
        {
            routerName = StringUtils.EMPTY;
        }
        return routerName;
    }

    /**
     * 获取路由地址
     *
     * @param menu 菜单信息
     * @return 路由地址
     */
    public String getRouterPath(SysMenu menu)
    {
        String routerPath = menu.getPath();
        // 内链打开外网方式
        if (menu.getParentId().intValue() != 0 && isInnerLink(menu))
        {
            routerPath = innerLinkReplaceEach(routerPath);
        }
        // 非外链并且是一级目录（类型为目录）
        if (0 == menu.getParentId().intValue() && UserConstants.TYPE_DIR.equals(menu.getMenuType())
                && UserConstants.NO_FRAME.equals(menu.getIsFrame()))
        {
            routerPath = "/" + menu.getPath();
        }
        // 非外链并且是一级目录（类型为菜单）
        else if (isMenuFrame(menu))
        {
            routerPath = "/";
        }
        return routerPath;
    }

    /**
     * 获取组件信息
     *
     * @param menu 菜单信息
     * @return 组件信息
     */
    public String getComponent(SysMenu menu)
    {
        String component = UserConstants.LAYOUT;
        if (StringUtils.isNotEmpty(menu.getComponent()) && !isMenuFrame(menu))
        {
            component = menu.getComponent();
        }
        else if (StringUtils.isEmpty(menu.getComponent()) && menu.getParentId().intValue() != 0 && isInnerLink(menu))
        {
            component = UserConstants.INNER_LINK;
        }
        else if (StringUtils.isEmpty(menu.getComponent()) && isParentView(menu))
        {
            component = UserConstants.PARENT_VIEW;
        }
        return component;
    }

    /**
     * 是否为菜单内部跳转
     *
     * @param menu 菜单信息
     * @return 结果
     */
    public boolean isMenuFrame(SysMenu menu)
    {
        return menu.getParentId().intValue() == 0 && UserConstants.TYPE_MENU.equals(menu.getMenuType())
                && menu.getIsFrame().equals(UserConstants.NO_FRAME);
    }

    /**
     * 是否为parent_view组件
     *
     * @param menu 菜单信息
     * @return 结果
     */
    public boolean isParentView(SysMenu menu)
    {
        return menu.getParentId().intValue() != 0 && UserConstants.TYPE_DIR.equals(menu.getMenuType());
    }

    /**
     * 是否为内链组件
     *
     * @param menu 菜单信息
     * @return 结果
     */
    public boolean isInnerLink(SysMenu menu)
    {
        return menu.getIsFrame().equals(UserConstants.NO_FRAME) && StringUtils.ishttp(menu.getPath());
    }

    /**
     * 根据父节点的ID获取所有子节点
     *
     * @param list 分类表
     * @param parentId 传入的父节点ID
     * @return String
     */
    public List<SysMenu> getChildPerms(List<SysMenu> list, int parentId)
    {
        List<SysMenu> returnList = new ArrayList<SysMenu>();
        for (Iterator<SysMenu> iterator = list.iterator(); iterator.hasNext();)
        {
            SysMenu t = (SysMenu) iterator.next();
            // 一、根据传入的某个父节点ID,遍历该父节点的所有子节点
            if (t.getParentId() == parentId)
            {
                recursionFn(list, t);
                returnList.add(t);
            }
        }
        return returnList;
    }

    /**
     * 递归列表
     *
     * @param list
     * @param t
     */
    private void recursionFn(List<SysMenu> list, SysMenu t)
    {
        // 得到子节点列表
        List<SysMenu> childList = getChildList(list, t);
        t.setChildren(childList);
        for (SysMenu tChild : childList)
        {
            if (hasChild(list, tChild))
            {
                recursionFn(list, tChild);
            }
        }
    }

    /**
     * 得到子节点列表
     */
    private List<SysMenu> getChildList(List<SysMenu> list, SysMenu t)
    {
        List<SysMenu> tlist = new ArrayList<SysMenu>();
        Iterator<SysMenu> it = list.iterator();
        while (it.hasNext())
        {
            SysMenu n = (SysMenu) it.next();
            if (n.getParentId().longValue() == t.getMenuId().longValue())
            {
                tlist.add(n);
            }
        }
        return tlist;
    }

    /**
     * 判断是否有子节点
     */
    private boolean hasChild(List<SysMenu> list, SysMenu t)
    {
        return getChildList(list, t).size() > 0;
    }

    /**
     * 内链域名特殊字符替换
     *
     * @return
     */
    public String innerLinkReplaceEach(String path)
    {
        return StringUtils.replaceEach(path, new String[] { Constants.HTTP, Constants.HTTPS, Constants.WWW, "." },
                new String[] { "", "", "", "/" });
    }
}
